use 5.010;
use strict;
use warnings;
use Test::More;
use autodie qw(:all);

BEGIN {
    use_ok "BlockDev";
}

my %part;
{
    open(my $pp => "/proc/partitions");
    while (<$pp>) { chomp;
	$. <= 2 and next;
	my ($ma, $mi, $si, $dev) = split;
	$part{$dev} = { major => $ma,
			minor => $mi,
			size => $si * 1024 };
    }
}

my @devices = BlockDev->list();
{   # device list

    is_deeply([sort @devices] => [sort keys %part], "got all devices");
}

foreach (@devices) {

    my $dev = BlockDev->new(dev => $_);
    isa_ok($dev, "BlockDev");

    ok(-b $dev->dev, "block device " . $dev->dev);
    is($dev->major, $part{$_}{major}, "major $_");
    is($dev->minor, $part{$_}{minor}, "minor $_");
    SKIP: {
	skip "need root permission" => 1 if $<;
	is($dev->size, $part{$_}{size}, "size $part{$_}{size}");
    }

}

done_testing();
